diff --git a/drivers/tty/serial/8250/8250_exar.c b/drivers/tty/serial/8250/8250_exar.c
index 0440df7de1ed..eb00fcd79a8e 100644
--- a/drivers/tty/serial/8250/8250_exar.c
+++ b/drivers/tty/serial/8250/8250_exar.c
@@ -46,9 +46,6 @@
 #define PCI_DEVICE_ID_COMMTECH_4228PCIE		0x0021
 #define PCI_DEVICE_ID_COMMTECH_4222PCIE		0x0022

-#define PCI_DEVICE_ID_EXAR_XR17V4358		0x4358
-#define PCI_DEVICE_ID_EXAR_XR17V8358		0x8358
-
 #define PCI_SUBDEVICE_ID_USR_2980		0x0128
 #define PCI_SUBDEVICE_ID_USR_2981		0x0129

diff --git a/include/linux/pci_ids.h b/include/linux/pci_ids.h
index a0c75e467df3..971c1a1c98e7 100644
--- a/include/linux/pci_ids.h
+++ b/include/linux/pci_ids.h
@@ -1809,35 +1809,76 @@

 #define PCI_VENDOR_ID_ALTEON		0x12ae

-#define PCI_SUBVENDOR_ID_CONNECT_TECH			0x12c4
-#define PCI_SUBDEVICE_ID_CONNECT_TECH_BH8_232		0x0001
-#define PCI_SUBDEVICE_ID_CONNECT_TECH_BH4_232		0x0002
-#define PCI_SUBDEVICE_ID_CONNECT_TECH_BH2_232		0x0003
-#define PCI_SUBDEVICE_ID_CONNECT_TECH_BH8_485		0x0004
-#define PCI_SUBDEVICE_ID_CONNECT_TECH_BH8_485_4_4	0x0005
-#define PCI_SUBDEVICE_ID_CONNECT_TECH_BH4_485		0x0006
-#define PCI_SUBDEVICE_ID_CONNECT_TECH_BH4_485_2_2	0x0007
-#define PCI_SUBDEVICE_ID_CONNECT_TECH_BH2_485		0x0008
-#define PCI_SUBDEVICE_ID_CONNECT_TECH_BH8_485_2_6	0x0009
-#define PCI_SUBDEVICE_ID_CONNECT_TECH_BH081101V1	0x000A
-#define PCI_SUBDEVICE_ID_CONNECT_TECH_BH041101V1	0x000B
-#define PCI_SUBDEVICE_ID_CONNECT_TECH_BH2_20MHZ		0x000C
-#define PCI_SUBDEVICE_ID_CONNECT_TECH_BH2_PTM		0x000D
-#define PCI_SUBDEVICE_ID_CONNECT_TECH_NT960PCI		0x0100
-#define PCI_SUBDEVICE_ID_CONNECT_TECH_TITAN_2		0x0201
-#define PCI_SUBDEVICE_ID_CONNECT_TECH_TITAN_4		0x0202
-#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_2_232	0x0300
-#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_4_232	0x0301
-#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_8_232	0x0302
-#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_1_1	0x0310
-#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_2_2	0x0311
-#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_4_4	0x0312
-#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_2	0x0320
-#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_4	0x0321
-#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_8	0x0322
-#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_2_485	0x0330
-#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_4_485	0x0331
-#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_8_485	0x0332
+#define PCI_VENDOR_ID_CONNECT_TECH				0x12c4
+#define PCI_DEVICE_ID_CONNECT_TECH_PCI_XR79X_12_XIG00X          0x110c
+#define PCI_DEVICE_ID_CONNECT_TECH_PCI_XR79X_12_XIG01X          0x110d
+#define PCI_DEVICE_ID_CONNECT_TECH_PCI_XR79X_16                 0x1110
+
+#define PCI_SUBVENDOR_ID_CONNECT_TECH				0x12c4
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_BH8_232			0x0001
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_BH4_232			0x0002
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_BH2_232			0x0003
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_BH8_485			0x0004
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_BH8_485_4_4		0x0005
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_BH4_485			0x0006
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_BH4_485_2_2		0x0007
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_BH2_485			0x0008
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_BH8_485_2_6		0x0009
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_BH081101V1		0x000A
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_BH041101V1		0x000B
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_BH2_20MHZ			0x000C
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_BH2_PTM			0x000D
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_NT960PCI			0x0100
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_TITAN_2			0x0201
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_TITAN_4			0x0202
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_TITAN_8			0x0203
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_2_232		0x0300
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_4_232		0x0301
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_8_232		0x0302
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_1_1		0x0310
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_2_2		0x0311
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_4_4		0x0312
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_2		0x0320
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_4		0x0321
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_8		0x0322
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_2_485		0x0330
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_4_485		0x0331
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_8_485		0x0332
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_2_SP_OPTO        0x0340
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_4_SP_OPTO_A      0x0341
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_4_SP_OPTO_B      0x0342
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_2_XPRS           0x0350
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_4_XPRS_A         0x0351
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_4_XPRS_B         0x0352
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_8_XPRS           0x0353
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_16_XPRS_A        0x0354
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_16_XPRS_B        0x0355
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_2_XPRS_OPTO      0x0360
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_4_XPRS_OPTO_A    0x0361
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_4_XPRS_OPTO_B    0x0362
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_8_SP             0x0370
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_8_SP_232         0x0371
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_8_SP_485         0x0372
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_4_4_SP           0x0373
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_6_2_SP           0x0374
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_2_6_SP           0x0375
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_8_SP_232_NS      0x0376
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_2_XP_OPTO_LEFT   0x0380
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_2_XP_OPTO_RIGHT  0x0381
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_4_XP_OPTO        0x0382
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_4_4_XPRS_OPTO    0x0392
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_8_XPRS_LP        0x03A0
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_8_XPRS_LP_232    0x03A1
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_8_XPRS_LP_485    0x03A2
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCI_UART_8_XPRS_LP_232_NS 0x03A3
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCIE_XEG001               0x0602
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCIE_XR35X_BASE           0x1000
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCIE_XR35X_2              0x1002
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCIE_XR35X_4              0x1004
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCIE_XR35X_8              0x1008
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCIE_XR35X_12             0x100C
+#define PCI_SUBDEVICE_ID_CONNECT_TECH_PCIE_XR35X_16             0x1010
+

 #define PCI_VENDOR_ID_NVIDIA_SGS	0x12d2
 #define PCI_DEVICE_ID_NVIDIA_SGS_RIVA128 0x0018
@@ -2048,9 +2089,14 @@
 #define PCI_DEVICE_ID_EXAR_XR17C152	0x0152
 #define PCI_DEVICE_ID_EXAR_XR17C154	0x0154
 #define PCI_DEVICE_ID_EXAR_XR17C158	0x0158
+#define PCI_DEVICE_ID_EXAR_XR17V252	0x0252
+#define PCI_DEVICE_ID_EXAR_XR17V254	0x0254
+#define PCI_DEVICE_ID_EXAR_XR17V258	0x0258
 #define PCI_DEVICE_ID_EXAR_XR17V352	0x0352
 #define PCI_DEVICE_ID_EXAR_XR17V354	0x0354
 #define PCI_DEVICE_ID_EXAR_XR17V358	0x0358
+#define PCI_DEVICE_ID_EXAR_XR17V4358    0x4358
+#define PCI_DEVICE_ID_EXAR_XR17V8358    0x8358

 #define PCI_VENDOR_ID_MICROGATE		0x13c0